common/models/User.php
<?php
namespace common\models;

use Yii;
use yii\base\NotSupportedException;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;
use yii\web\IdentityInterface;

/**
 * User model
 *
 * @property integer $id
 * @property string $username
 * @property string $phone
 * @property string $company
 * @property string $password_hash
 * @property string $password_reset_token
 * @property string $email
 * @property string $auth_key
 * @property integer $status
 * @property integer $created_at
 * @property integer $updated_at
 * @property string $password write-only password
 */
class User extends ActiveRecord implements IdentityInterface
{
    const STATUS_DELETED = 0;
    const STATUS_ACTIVE = 10;


    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return '{{%user}}';
    }

    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            TimestampBehavior::className(),
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            ['status', 'default', 'value' => self::STATUS_ACTIVE],
            ['status', 'in', 'range' => [self::STATUS_ACTIVE, self::STATUS_DELETED]],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return static::findOne(['id' => $id, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        throw new NotSupportedException('"findIdentityByAccessToken" is not implemented.');
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        return static::findOne(['username' => $username, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * Finds user by password reset token
     *
     * @param string $token password reset token
     * @return static|null
     */
    public static function findByPasswordResetToken($token)
    {
        if (!static::isPasswordResetTokenValid($token)) {
            return null;
        }

        return static::findOne([
            'password_reset_token' => $token,
            'status' => self::STATUS_ACTIVE,
        ]);
    }

    /**
     * Finds out if password reset token is valid
     *
     * @param string $token password reset token
     * @return bool
     */
    public static function isPasswordResetTokenValid($token)
    {
        if (empty($token)) {
            return false;
        }

        $timestamp = (int) substr($token, strrpos($token, '_') + 1);
        $expire = Yii::$app->params['user.passwordResetTokenExpire'];
        return $timestamp + $expire >= time();
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->getPrimaryKey();
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->auth_key;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->getAuthKey() === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return Yii::$app->security->validatePassword($password, $this->password_hash);
    }

    /**
     * Generates password hash from password and sets it to the model
     *
     * @param string $password
     */
    public function setPassword($password)
    {
        $this->password_hash = Yii::$app->security->generatePasswordHash($password);
    }

    /**
     * Generates "remember me" authentication key
     */
    public function generateAuthKey()
    {
        $this->auth_key = Yii::$app->security->generateRandomString();
    }

    /**
     * Generates new password reset token
     */
    public function generatePasswordResetToken()
    {
        $this->password_reset_token = Yii::$app->security->generateRandomString() . '_' . time();
    }

    /**
     * Removes password reset token
     */
    public function removePasswordResetToken()
    {
        $this->password_reset_token = null;
    }

    public function getSubscribe()
    {
        return $this->hasOne(Subscription::className(), ['user_id' => 'id']);
    }

    public function getSubscribes()
    {
        return $this->hasMany(Subscription::className(), ['user_id' => 'id']);
    }

    public function getPostSubscribe()
    {
        return $this->hasOne(Subscription::className(), ['user_id' => 'id'])->where(['type' => 1, 'status' => 1]);
    }

    public function getLogoSubscribe()
    {
        return $this->hasOne(Subscription::className(), ['user_id' => 'id'])->where(['type' => 2, 'status' => 1]);
    }

    public function getSmmSubscribe()
    {
        return $this->hasOne(Subscription::className(), ['user_id' => 'id'])->where(['type' => 3, 'status' => 1]);
    }

    public function getLogoCount()
    {
        $logo = Logo::find()->where(['user_id' => $this->id])->one();
        if ($logo) {
            return 1;
        }
        else {
            return 0;
        }
    }
}

frontend/controllers/SmmController.php
<?php
namespace frontend\controllers;

use common\models\NumberBase;
use common\models\SmmPlan;
use common\models\SmsCampaigne;
use common\models\SmsName;
use common\models\Target;
use frontend\models\SendSmsForm;
use Yii;
use yii\base\InvalidParamException;
use yii\helpers\ArrayHelper;
use yii\helpers\VarDumper;
use yii\web\BadRequestHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use common\models\LoginForm;
use frontend\models\PasswordResetRequestForm;
use frontend\models\ResetPasswordForm;
use frontend\models\SignupForm;
use frontend\models\ContactForm;
use common\components\Controller;

class SmmController extends Controller
{
    /**
     * {@inheritdoc}
     */

    public function Behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => [ ''],
                'rules' => [
                    [
                        'actions' => [''],
                        'allow' => true,
                        'roles' => ['viewSmmPage'],
                    ],
                ],
            ],
        ];
    }
    //App home page
    public function actionIndex()
    {

        $smm_plans = SmmPlan::find()->all();
        return $this->render('index2', [
            'price_plans' => $smm_plans
        ]);
    }

    //Create post

    public function actionAppPage()
    {
        if (!Yii::$app->user->can('viewSmmPage')) {
            return $this->render('not-subscribed');
        }
        return $this->render('index');

    }

}

frontend/views/smm/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\Pjax;
/* @var $this yii\web\View */
/* @var $searchModel common\models\LogoSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('main', 'smm');
$this->params['breadcrumbs'][] = $this->title;
?>

<section class="page-title parallax-section" style="height:80px;padding-top: 0; padding-bottom: 0">
    <div class="row-parallax-bg">
        <div class="parallax-wrapper">
            <div class="parallax-bg">
                <img src="/layout/images/bg-image-30.jpg" alt="">
            </div>
        </div>
        <div class="parallax-overlay"></div>
    </div>
    <div class="centrize">
        <div class="v-center">
            <div class="container">

            </div>
        </div>
    </div>
</section>
<section>
    <div class="container">
        <div class="section-content">
            <div class="row">
                <div class="col-md-3">
                    <div class="icon-box-app">
                        <ul class="app-navigation">
                            <li><a href="<?= Url::to(['app/index']) ?>"><?= Yii::t('main','profile') ?></a></li>
                            <li ><a href="<?= Url::to(['post/index']) ?>"><?= Yii::t('main','order_post') ?></a></li>
                            <li><a href="<?= Url::to(['logo/index']) ?>"><?= Yii::t('main','order_logo') ?></a></li>
                            <li class="active"><a href="<?= Url::to(['/smm']) ?>"><?= Yii::t('main','smm') ?></a></li>
                            <li><a href="<?= Url::to(['site/logout']) ?>"><?=Yii::t('main','logout')?></a></li>
                        </ul>

                    </div>
                </div>
                <div class="col-md-9">
                    <div class="icon-box-app">
                        <div style="margin-bottom: 20px">
                            <i style="font-size: 20px;" class="fa fa-paper-plane"></i>
                            <strong><?=$this->title?></strong>
                        </div>
                        <div class="row justify-content-center">
                            <div class="col-sm-12 col-md-12">
                                <div class="card">
                                </div>
                                <div class="card-body">
                                    <table class="table table-responsive-sm table-striped">
                                        <tbody>
                                        <tr>
                                            <td><?= Yii::t('main','active_smm_plan') ?></td>
                                            <td><span class="badge badge-success"><?= Yii::$app->user->identity->smmSubscribe->plan->name?></span></td>
                                        </tr>
                                        <?php $features = explode(',', Yii::$app->user->identity->smmSubscribe->plan->plan) ?>
                                        <tr>
                                            <td>Etibarlıdır :</td>
                                            <td><span class="badge badge-success"><?= date("Y-m-d", strtotime("+1 month", Yii::$app->user->identity->smmSubscribe->created_at))?></span></td>
                                        </tr>
                                        </tbody>
                                    </table>

                                </div>
                            </div>
                            </div>

                        </div>

                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

frontend/views/smm/not-subscribed.php
<?php

/**
 * Created by PhpStorm.
 * User: ali
 * Date: 2019-01-10
 * Time: 19:49
 */

use yii\helpers\Url; ?>
<section class="page-title parallax-section" style="height:80px;padding-top: 0; padding-bottom: 0">
    <div class="row-parallax-bg">
        <div class="parallax-wrapper">
            <div class="parallax-bg">
                <img src="/layout/images/bg-image-30.jpg" alt="">
            </div>
        </div>
        <div class="parallax-overlay"></div>
    </div>
    <div class="centrize">
        <div class="v-center">
            <div class="container">

            </div>
        </div>
    </div>
</section>
<section>
    <div class="container">
        <div class="section-content">
            <div class="row">
                <div class="col-md-3">
                    <div class="icon-box-app">
                        <ul class="app-navigation">
                            <li class=""><a href="<?= Url::to(['app/index']) ?>">Hesabım</a></li>
                            <li class=""><a href="<?= Url::to(['post/index']) ?>">Post sifarişi</a></li>
                            <li class=""><a href="<?= Url::to(['logo/index']) ?>">Logo sifarişi</a></li>
                            <li class="active"><a href="<?= Url::to(['smm/index']) ?>">SMM sifarişi</a></li>
                            <li><a href="<?= Url::to(['site/logout']) ?>"><?= Yii::t('main', 'logout') ?></a></li>
                        </ul>

                    </div>
                </div>
                <div class="col-md-9">
                    <div class="icon-box-app">
                        <i style="font-size: 20px;" class="fa fa-paper-plane"></i>
                        <strong><?= $this->title ?></strong>
                        <h3 style="text-align: center;"><?= Yii::t('main', 'You are not subscribed') ?></h3>
                        <div style="    text-align: center;
    margin-top: 40px;">
                            <a class="btn btn-color btn-sm" href="<?=Url::to(['/posts'])?>" data-custom-bg="rgb(255, 213, 0)" style="background-color: rgb(255, 213, 0);" tabindex="0">
                                <?= Yii::t('main', 'View our post pacckages') ?>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>